package com.example.smartcardapp;

import java.util.HashMap;
import java.util.Iterator;









import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbManager;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.util.Log;


import amlib.hw.HWType;
import amlib.ccid.Reader;
import amlib.hw.HardwareInterface;
import amlib.ccid.Error;


public class TestActivity extends Activity {
	private Reader mReader;
	private HardwareInterface mMyDev;
	private UsbDevice mUsbDev;
	private UsbManager mManager;
	Builder  mSlotDialog;
	Builder  mPowerDialog;
	private byte mSlotNum;
	private PendingIntent mPermissionIntent;
	private Button mListButton;
	private Button mOpenButton;
	private Button mPowerButton;
	private Button mATRButton;
	private Button mAPDUButton;
	private Button mProtocolButton;
	private Button mSNButton;
	private Button mSwitchButton;
	private Button mCloseButton;
	private ArrayAdapter<String> mReaderAdapter;
	private TextView mTextViewReader;
	private TextView mTextViewResult; 
	private EditText mEditTextApdu;
	private ProgressDialog mCloseProgress; 
	//private EditText mEditTextMode;
	
	private Spinner mModeSpinner;
	private Spinner mReaderSpinner;
	private ArrayAdapter<String> mModeList;
//	private ArrayAdapter<String> mModeAdapter;
	private String mStrMessage;
	private final String mode2 = "I2c Mode";
	private final String mode3 = "SLE4428 Mode";
	private final byte DEFAULT_SN_LEN = 32;
	private Context mContext;


	private static final String TAG = "Alcor-Test";
	private static final String ACTION_USB_PERMISSION = "com.android.example.USB_PERMISSION";
	

  
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_test);
		setupViews();
		mSlotNum = (byte)0;
		mContext = getApplicationContext();
	    
		Log.d(TAG," onCreate");
		try {
			mMyDev = new HardwareInterface(HWType.eUSB);
			mMyDev.setLog(mContext,true, 0xff);
			
		}catch(Exception e){
			mStrMessage = "Get Exception : " + e.getMessage();
			Log.e(TAG, mStrMessage);
			return;
		}
		// Get USB manager
		Log.d(TAG," mManager");
        mManager = (UsbManager) getSystemService(Context.USB_SERVICE);
        toRegisterReceiver();
	}

	protected void onResume() {
		Log.d(TAG, "Activity onResume");
		super.onResume();
	}
	
	protected void onPause() {
		Log.d(TAG, "Activity OnPause");
		super.onPause();
	}
	
	protected void   onStop() {
		Log.d(TAG, "Activity onStop");
		super.onStop();
	}
	
	protected void   onDestroy() {
		unregisterReceiver(mReceiver);
		if (mMyDev != null)
			mMyDev.Close();
		if (mReader != null)
			mReader.destroy();
		super.onDestroy();
		//android.os.Process.killProcess(android.os.Process.myPid());
	}
	
	public void setupViews(){
		String[] pMode = new String[] {mode2, mode3};
		
		mListButton = (Button)findViewById(R.id.buttonList);
		mPowerButton = (Button)findViewById(R.id.buttonPower);
		mOpenButton = (Button)findViewById(R.id.buttonOpen);
		mATRButton  = (Button)findViewById(R.id.buttonATR);
		mAPDUButton = (Button)findViewById(R.id.buttonAPDU);
		mProtocolButton = (Button)findViewById(R.id.buttonProtocol);
		mSNButton = (Button)findViewById(R.id.buttonSN);
		mSwitchButton = (Button)findViewById(R.id.buttonSwitch);
		mCloseButton = (Button)findViewById(R.id.buttonClose);
		
		onCreateButtonSetup();
		
		
		mTextViewReader = (TextView)findViewById(R.id.textReader);
    	mTextViewResult = (TextView)findViewById(R.id.textResult);
    	mEditTextApdu = (EditText)findViewById(R.id.editTextAPDU);
    	mEditTextApdu.setText("A0A40000023F00");
    
    	//mEditTextMode = (EditText)findViewById(R.id.textMode);
    	//mEditTextMode.setText("1");
    	mModeSpinner = (Spinner) findViewById(R.id.modeSpinner);
    	
    	mModeList = new ArrayAdapter<String>(this,  
    			android.R.layout.simple_spinner_item, pMode);  	
    	
    	mModeList.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    	mModeSpinner.setAdapter(mModeList);
    	setupReaderSpinner();
        setReaderSlotView();
        setPowerView();
 
	}
	
	
	private void toRegisterReceiver(){
		 // Register receiver for USB permission
        mPermissionIntent = PendingIntent.getBroadcast(this, 0, new Intent(ACTION_USB_PERMISSION), 0);
        IntentFilter filter = new IntentFilter();
        filter.addAction(ACTION_USB_PERMISSION);
        filter.addAction(UsbManager.ACTION_USB_DEVICE_DETACHED);
        registerReceiver(mReceiver, filter);
	}
	
	private void setupReaderSpinner(){
		// Initialize reader spinner
        mReaderAdapter = new ArrayAdapter<String>(this,
                android.R.layout.simple_spinner_item);
        
        mReaderSpinner = (Spinner) findViewById(R.id.spinnerDevice);
        mReaderSpinner.setAdapter(mReaderAdapter);
        mReaderSpinner.setOnItemSelectedListener(new OnItemSelectedListener(){

            @Override
            public void onItemSelected(AdapterView<?> arg0, View arg1,int position, long arg3) {
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
               // TODO Auto-generated method stub
            }
        });
	}
	
	private void setReaderSlotView(){
		final String [] arraySlot = new String[] {"slot:0","Slot:1"};
		mSlotDialog = new AlertDialog.Builder(this);
		DialogInterface.OnClickListener Select = new DialogInterface.OnClickListener(){
			
			@Override  
			public void onClick(DialogInterface dialog, int which) {
				mSlotNum = (byte) which;
			}  
		};
		
		DialogInterface.OnClickListener OkClick = new DialogInterface.OnClickListener()
		{
			public void onClick(DialogInterface dialog, int which) {
				requestDevPerm();
			}
		}; 
		
		mSlotDialog.setPositiveButton("OK",OkClick );
		mSlotDialog.setTitle("Select Slot Number");
		mSlotDialog.setSingleChoiceItems(arraySlot, 0, Select) ;
		
	}

	private void setPowerView(){
		mPowerDialog = new AlertDialog.Builder(this);
		DialogInterface.OnClickListener poweroffClick = new DialogInterface.OnClickListener(){
			@Override  
			public void onClick(DialogInterface dialog, int which) {
				TextView textViewResult;
				int ret;
				textViewResult = (TextView)findViewById(R.id.textResult);
				ret =	poweroff();
				if (ret == Error.READER_SUCCESSFUL)
					textViewResult.setText("power off successfully");
				else if ( ret == Error.READER_NO_CARD){
					textViewResult.setText("Card Absent");
				}
				else
					textViewResult.setText("power off fail:"+  Integer.toString(ret));
			}  
		};
		
		DialogInterface.OnClickListener poweronClick = new DialogInterface.OnClickListener()
		{
			public void onClick(DialogInterface dialog, int which) {
				TextView textViewResult;
				int ret;
				textViewResult = (TextView)findViewById(R.id.textResult);
				ret =	poweron();
				if (ret == Error.READER_SUCCESSFUL)
				{
					textViewResult.setText("power on successfully");
				}
				else if ( ret == Error.READER_NO_CARD){
					textViewResult.setText("Card Absent");
				}
				else
					textViewResult.setText("power on fail:"+  Integer.toString(ret));
			}
		}; 
		mPowerDialog.setTitle("Set Power");
		mPowerDialog.setNeutralButton("PowerON", poweronClick);
		mPowerDialog.setPositiveButton("PowerOFF", poweroffClick);
	}
	
	
	private void checkSlotNumber(UsbDevice uDev){
		if(uDev.getProductId() == 0x9522 || uDev.getProductId() == 0x9525 ||uDev.getProductId() == 0x9526 )
			mSlotDialog.show();
		else{
			mSlotNum = (byte)0;
			requestDevPerm();
		}
	}
	
	private void updateViewReader(){
		int pid; 
		int vid;
		try {
			pid = mUsbDev.getProductId();
			vid = mUsbDev.getVendorId();
		}catch(NullPointerException e){
			mStrMessage = "Get Exception : " + e.getMessage();
			Log.e(TAG, mStrMessage);
			return;
		}
		mTextViewReader.setText("Reader:"+ Integer.toHexString(vid) + " " +  Integer.toHexString(pid));
	}
	
	private void updateReaderList(Intent intent){
		// Update reader list
		mReaderAdapter.clear();
		for (UsbDevice device : mManager.getDeviceList().values()) {
			Log.d(TAG, "Update reader list : " + device.getDeviceName());
			if(isAlcorReader(device))
				mReaderAdapter.add(device.getDeviceName());
		}   

		UsbDevice device = (UsbDevice) intent
				.getParcelableExtra(UsbManager.EXTRA_DEVICE);
	}

	private UsbDevice getSpinnerSelect(){
		String deviceName;
		deviceName= (String) mReaderSpinner.getSelectedItem();
        if (deviceName != null) {
             // For each device
             for (UsbDevice device : mManager.getDeviceList().values()) {
                 if (deviceName.equals(device.getDeviceName())) {
                	 return device;
                 }
             }
        }
        return null;
	}
	
	private void requestDevPerm(){
		UsbDevice dev = getSpinnerSelect();
		if (dev != null)
			mManager.requestPermission(dev, mPermissionIntent);
		else
			Log.e(TAG,"selected not found");
	}
	
	
	public void ListOnClick(View view){
		Log.d(TAG, "ListOnClick");
		EnumeDev();
	}
	
	public void SpinnerDeviceOnClick(View view){
		Log.d(TAG, "SpinnerDeviceOnClick");
		EnumeDev();
	}

	public void OpenOnClick(View view){
		Log.d(TAG, "OpentOnClick");
    	UsbDevice dev = getSpinnerSelect();
		if (dev != null)
			checkSlotNumber(dev);
	}
	
	public void PowerOnClick(View view){
		Log.d(TAG, "PowerOnClick");
		mPowerDialog.show();
		
	}
	public void getATROnClick(View view){
		
		String atr;
		Log.d(TAG, "getATROnClick");
		try {
			atr = mReader.getAtrString();
			mTextViewResult.setText(" ATR:"+ atr);
			//mATRButton.setEnabled(false);
		}
		catch (Exception e){
			mStrMessage = "Get Exception : " + e.getMessage();
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
		}
	}

	public void sendAPDUkOnClick(View view){
		byte[] pSendAPDU ;
		byte[] pRecvRes = new byte[300];
		int[] pRevAPDULen = new int[1];
		String apduStr;
		int sendLen, result;

		Log.d(TAG, "sendAPDUkOnClick");
		pRevAPDULen[0] = 300;
		apduStr = mEditTextApdu.getText(). toString();
		pSendAPDU = toByteArray(apduStr);
		sendLen = pSendAPDU.length; 
		
		try{
			result = mReader.transmit(pSendAPDU, sendLen, pRecvRes, pRevAPDULen);
			if (result == Error.READER_SUCCESSFUL){
				mTextViewResult.setText("Receive APDU: "+ logBuffer(pRecvRes, pRevAPDULen[0]));
			}
			else{
				mTextViewResult.setText("Fail to Send APDU: " + Integer.toString(result)
						 + "("+ Integer.toHexString(mReader.getCmdFailCode()) +")");
				Log.e(TAG, "Fail to Send APDU: " + Integer.toString(result)
						 + "("+ Integer.toHexString(mReader.getCmdFailCode()) +")");
			}
		}catch (Exception e){
			mStrMessage = "Get Exception : " + e.getMessage();
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
		}
	}
	
	
	
	public void getProtocolOnClick(View view){
		int status;
		byte []proto = new byte[1];
		Log.d(TAG, "getProtocolOnClick");

		try {
    		status = mReader.getProtocol(proto);
    	}
        catch(Exception e){
			mStrMessage = "Get Exception : " + e.getMessage();
			mTextViewResult.setText( mStrMessage); 
			return ;
		}
    	
		if (status != Error.READER_SUCCESSFUL){
			mTextViewResult.setText("getProtocol fail: "+ Integer.toString(status)
					+ "("+ Integer.toHexString(mReader.getCmdFailCode()) +")");
			Log.e(TAG, "getProtocol fail: "+ Integer.toString(status)
					+ "("+ Integer.toHexString(mReader.getCmdFailCode()) +")");
		}else{
			if (proto[0] == Reader.CCID_PROTOCOL_T0)
				mTextViewResult.setText("T0");
			if (proto[0] == Reader.CCID_PROTOCOL_T1)
				mTextViewResult.setText("T1");
		}
	}
	
	public void getSNOnClick(View view){
		//boolean status;
		int status = 0;
		byte pLen[] = new byte[1];
		byte []pSN;
		Log.d(TAG, "getSNOnClick");
		pLen[0] = DEFAULT_SN_LEN;
		pSN = new byte[pLen[0]];
		try {
    		//status = mReader.getSN(pSN, pLen);
			//status = mMyDev.getSerialNumber(pSN, pLen);
			status = mReader.getSN(pSN, pLen);
    	}
        catch(Exception e){
    		
			mStrMessage = "Get Exception : " + e.getMessage();
			mTextViewResult.setText( mStrMessage); 
			return ;
		}
    	
		if (status != Error.READER_SUCCESSFUL){
			
			mTextViewResult.setText("getSN fail: " 
					+ "("+ Integer.toHexString(mReader.getCmdFailCode()) +")");
		}else{
			String str = new String(pSN);
			//mTextSN.setText(logBuffer(pSN, pLen[0]));
			mTextViewResult.setText(str);
		}
	}
		
	private int getSlotStatus(){
		int ret = Error.READER_NO_CARD;
		byte []pCardStatus = new byte[1];

			/*detect card hotplug events*/
			try{
				if (mReader.getCardStatus(pCardStatus) == Error.READER_SUCCESSFUL){	
					//Log.d(TAG,"cmd OK  mSlotStatus = " +mSlotStatus);
					if (pCardStatus[0] == Reader.SLOT_STATUS_CARD_ABSENT ){
						ret = Error.READER_NO_CARD;
					}
					else 
						ret = Error.READER_SUCCESSFUL;
				}
			}
			catch (Exception e){
				mStrMessage = "Get Exception : " + e.getMessage();
				mTextViewResult.setText( mStrMessage); 
			}
		return ret;
	}
//	public void switchModeOnClick(View view){
//		byte mode = 0x01;
//		int result;
//		String modeString;
//		//textMode 
//		//mEditTextMode.getText().to;
//		modeString = (String)mModeSpinner.getSelectedItem();
//		Log.d(TAG ,"selected :" + modeString);
//		if ( modeString.compareTo(mode2) == 0){
//			mode = 0x2;
//			mode = 0x3;
//		}
//
//		//mode = (byte) (Integer.parseInt(mEditTextMode.getText().toString()) & 0xff);
//		try{
//			
//			if (result == error.READER_SUCCESSFUL){
//				mTextMode.setText("switch mode successfully");
//			}
//			else{
//				mTextMode.setText("switch mode Fail" + "("+ Integer.toHexString(mReader.getCmdFailCode()) +")");
//			}
//		}catch (Exception e){
//			mStrMessage = "Get Exception : " + e.getMessage();
//			Log.e(TAG, mStrMessage);
//			mTextViewATR.setText(mStrMessage);
//			
//		}
//		 
//	}
	
	
	public void CloseOnClick(View view){
		new CloseTask().execute();
	}
	
	
	
	private class OpenTask extends AsyncTask <UsbDevice, Void, Integer> {

        @Override
        protected Integer doInBackground(UsbDevice... params) {
            int status = 0;
            try {
            	status = InitReader() ;
            	if ( status != 0){
            		Log.e(TAG, "fail to initial reader");
            		return status;
            	}
            	//status = mReader.connect();
            } catch (Exception e) {
            	mStrMessage = "Get Exception : " + e.getMessage();
            	mTextViewResult.setText( mStrMessage); 
            }
            return status;
        }

        @Override
        protected void onPostExecute(Integer result) {
            if (result != 0) {
            	mTextViewResult.setText("Open fail: "+ Integer.toString(result));
            	Log.e(TAG,"Open fail: "+ Integer.toString(result));
    		}else{
    			onOpenButtonSetup();
    			mTextViewResult.setText("Open successfully");
    			Log.e(TAG,"Open successfully");
            }
		}
    }

	private int closeReaderUp(){
		Log.d(TAG, "Closing reader...");
		int ret = 0;
		
		if (mReader!= null)
		{
			ret = mReader.close();
		}
		return ret;
	}
	private void closeReaderBottom(){
		onCloseButtonSetup();
		cleanText();
		mMyDev.Close();
		mSlotNum = (byte)0;
	}
	
	private void setUpCloseDialog(){
		mCloseProgress =  new ProgressDialog(TestActivity.this);  
        mCloseProgress.setMessage("Closing Reader");
        mCloseProgress.setCancelable(false);
        mCloseProgress.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        mCloseProgress.show();
	}

	private class CloseTask extends AsyncTask <Void, Void, Integer> {
		
		@Override 
		protected void onPreExecute() {
			setUpCloseDialog();
			
		}
        @Override
        protected Integer doInBackground(Void... params) {
            int status = 0;
            try {
            	do{
            		status = closeReaderUp();
            	}while(status == Error.READER_CMD_BUSY);
            	
            } catch (Exception e) {
            	mStrMessage = "Get Exception : " + e.getMessage();
            	mTextViewResult.setText( mStrMessage); 
            }
           
            return status;
        }

        @Override
        protected void onPostExecute(Integer result) {
            if (result != 0) {
            	mTextViewResult.setText("Close fail: "+ Integer.toString(result));
            	Log.e(TAG, "Close fail: "+ Integer.toString(result));
    		}else{
    			mTextViewResult.setText("Close successfully");
    			Log.e(TAG,"Close successfully");
            }
            closeReaderBottom();
            mCloseProgress.dismiss();
		}
    }
	
	private int poweron(){
		int result = Error.READER_SUCCESSFUL;
		Log.d(TAG,"poweron");
		//check slot status first
		if ( getSlotStatus() == Error.READER_NO_CARD){
			mTextViewResult.setText("Card Absent");
			Log.d(TAG,"Card Absent");
			return Error.READER_NO_CARD;
		}
		try {
			result = mReader.setPower(Reader.CCID_POWERON);
		}catch(Exception e){
			Log.e(TAG, "PowerON Get Exception : " + e.getMessage());
		}
		return result;
	}
	
	private int poweroff(){
		int result =  Error.READER_SUCCESSFUL;
		Log.d(TAG,"poweroff");
		if ( getSlotStatus() == Error.READER_NO_CARD){
			mTextViewResult.setText("Card Absent");
			Log.d(TAG,"Card Absent");
			return Error.READER_NO_CARD;
		}
		//----------poweroff card------------------
		try {
			result = mReader.setPower(Reader.CCID_POWEROFF);	
		}catch(Exception e){
			Log.e(TAG, "PowerOFF Get Exception : " + e.getMessage());
		}	
		return result;
	}
	
	public void cleanText(){	
		mTextViewResult.setText("");
		mTextViewReader.setText("");
		
	}
	
	private void onCreateButtonSetup(){
		mListButton.setEnabled(true);
		mOpenButton.setEnabled(true);
		mPowerButton.setEnabled(false);
		mATRButton.setEnabled(false);
		mAPDUButton.setEnabled(false);
		mSNButton.setEnabled(false);
		mProtocolButton.setEnabled(false);
		mSwitchButton.setEnabled(false);
		mCloseButton.setEnabled(false);
	}
	
	private void onOpenButtonSetup(){
		mOpenButton.setEnabled(false);
		mPowerButton.setEnabled(true);
    	mATRButton.setEnabled(true);
		mAPDUButton.setEnabled(true);
		mSNButton.setEnabled(true);
		mProtocolButton.setEnabled(true);
		mCloseButton.setEnabled(true);
	}
	private void onCloseButtonSetup(){
		mOpenButton.setEnabled(true);
		mPowerButton.setEnabled(false);
		mATRButton.setEnabled(false);
		mAPDUButton.setEnabled(false);
		mSNButton.setEnabled(false);
		mProtocolButton.setEnabled(false);
		mSwitchButton.setEnabled(false);
		mCloseButton.setEnabled(false);
	}
	
	
	
	
	private void onDevPermit(UsbDevice dev){
		mUsbDev = dev;
		try {    		
			updateViewReader();
			new OpenTask().execute(dev);
		}
		catch(Exception e){
			mStrMessage = "Get Exception : " + e.getMessage();
			Log.e(TAG, mStrMessage);
		}
	}
	
	
	
	private void onDetache(Intent intent){
		UsbDevice   udev = (UsbDevice) intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
    	if (udev != null ) {
    		if (udev.equals(mUsbDev) ){
    			closeReaderUp();
    			closeReaderBottom();
    		}
    	}
    	else {
    		Log.d(TAG,"usb device is null");
    	}
	}
	
	private final BroadcastReceiver mReceiver = new BroadcastReceiver() {

    	public void onReceive(Context context, Intent intent) {
           	Log.d(TAG, "Broadcast Receiver");
            
            String action = intent.getAction();
            if (ACTION_USB_PERMISSION.equals(action)) {
                synchronized (this) {
                    UsbDevice device = (UsbDevice) intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
                    if (intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false)) {
                        if (device != null) {
                        	onDevPermit(device);
                        }
                    } else {
                       	Log.d(TAG, "Permission denied for device " + device.getDeviceName());
                    }
                }

            } else if (UsbManager.ACTION_USB_DEVICE_DETACHED.equals(action)) {
           	
            	Log.d(TAG, "Device Detached");
            	onDetache(intent);
            	
                synchronized (this) {
                	updateReaderList(intent);
                } 
            	
            }
        }/*end of onReceive(Context context, Intent intent) {*/
    };
    
    
    private boolean isAlcorReader(UsbDevice udev){
    	if (udev.getVendorId() == 0x058f
    			&& ((udev.getProductId() == 0x9540) || (udev.getProductId() == 0x9560)
    					 || (udev.getProductId() == 0x9520)  || (udev.getProductId() == 0x9522)
    					 || (udev.getProductId() == 0x9525) || (udev.getProductId() == 0x9526))
    			)
	    		 return true;
    	return false;
    }
    
    private int EnumeDev()
    { 
    	UsbDevice device = null;    
    	UsbManager manager = (UsbManager) getSystemService(Context.USB_SERVICE);
    	
    	HashMap<String, UsbDevice> deviceList = manager.getDeviceList();
    	Iterator<UsbDevice> deviceIterator = deviceList.values().iterator();
    	Log.d(TAG," EnumeDev");
    	mReaderAdapter.clear();
    	while(deviceIterator.hasNext()){
    		 device = deviceIterator.next();   
    	    Log.d(TAG," "+ Integer.toHexString(device.getVendorId()) +" " +Integer.toHexString(device.getProductId()));
    	    if(isAlcorReader(device)) 
    		{       
    	    	Log.d(TAG,"Found Device");
    	    	mReaderAdapter.add(device.getDeviceName());	
    		} 
    	}
    	//requestDevPerm();
    		
		return 0;
    }
    
    private int InitReader()
    {
    	int Status = 0;
    	boolean init;// 
    	Log.d(TAG, "InitReader");
    	try {
    		init = mMyDev.Init(mManager, mUsbDev);
    		if (!init){
        		Log.e(TAG, "Device init fail");
        		return -1;
        	}
    	//	mMyDev.setLog(mContext,true, 0xff);
    		mReader = new Reader(mMyDev);
    		mReader.setSlot(mSlotNum);
    		
    	}
        catch(Exception e){
    		
			mStrMessage = "Get Exception : " + e.getMessage();
			Log.e(TAG, mStrMessage);
			return -1;
		}
    	return Status;
    }
    
    private byte[] toByteArray(String hexString) {

        int hexStringLength = hexString.length();
        byte[] byteArray = null;
        int count = 0;
        char c;
        int i;

        // Count number of hex characters
        for (i = 0; i < hexStringLength; i++) {

            c = hexString.charAt(i);
            if (c >= '0' && c <= '9' || c >= 'A' && c <= 'F' || c >= 'a'
                    && c <= 'f') {
                count++;
            }
        }

        byteArray = new byte[(count + 1) / 2];
        boolean first = true;
        int len = 0;
        int value;
        for (i = 0; i < hexStringLength; i++) {

            c = hexString.charAt(i);
            if (c >= '0' && c <= '9') {
                value = c - '0';
            } else if (c >= 'A' && c <= 'F') {
                value = c - 'A' + 10;
            } else if (c >= 'a' && c <= 'f') {
                value = c - 'a' + 10;
            } else {
                value = -1;
            }

            if (value >= 0) {

                if (first) {

                    byteArray[len] = (byte) (value << 4);

                } else {

                    byteArray[len] |= value;
                    len++;
                }

                first = !first;
            }
        }

        return byteArray;
    }
    
    private String logBuffer(byte[] buffer, int bufferLength) {

        String bufferString = "";
        String dbgString = "";

        for (int i = 0; i < bufferLength; i++) {

            String hexChar = Integer.toHexString(buffer[i] & 0xFF);
            if (hexChar.length() == 1) {
                hexChar = "0" + hexChar;
            }

            if (i % 16 == 0) {
                if (dbgString != "") {
//                    Log.d(LOG_TAG, dbgString);
            		bufferString += dbgString;
                    dbgString = "";
                }
            }

            dbgString += hexChar.toUpperCase() + " ";
        }

        if (dbgString != "") {
//        	Log.d(LOG_TAG, dbgString);
        	bufferString += dbgString;
        }
        
        return bufferString;
    }
}


